;; Copyright (c) 1996 Oscar Waddell
;;
;; See the file "Notice" for information on usage and redistribution
;; of this file, and for a DISCLAIMER OF ALL WARRANTIES.


;; Note to Wally:
;;   I think you can get the "single-threaded" feel you want by changing
;;   mode (in swl:event-dispatch) to something other than 'dispatch.
;;   Don't worry, the optimizer will clean up the apparent eq? test at
;;   compile time.


;;
;; 1/15 (johnz) this is almost identical to the standard Chez error handler.
;; it is not needed to work with threads.  assuming it was temporary hack.
;; 
;;(define swl:report-error
;;  (lambda (what who msg args)
;;    (let ([who (if who (format "~a" who) "")]
;;          [msg (parameterize ([print-level 3] [print-length 6])
;;                  (apply format msg args))])
;;      (let ([who (if (string=? who "") "" (format " in ~a" who))]
;;            [msg (if (string=? msg "") "" (format ": ~a" msg))])
;;        (fprintf (console-output-port) "~%~a~a~a.~%" what who msg)
;;        (flush-output-port (console-output-port))))))

(define swl:default-quantum thread-default-quantum)
;;  old paranoid code
;;
;;  (define swl:event-dispatch
;;    (lambda ()
;;      (let loop ()
;;        (call-with-values
;;          (lambda () (do-event))
;;          (lambda (fallback-id args)
;;            (when fallback-id
;;              (when (eq? (swl:bug) 'dispatch)
;;                (fprintf (swl:bug-port) "x-thread ~s ~s~n" fallback-id args))
;;              (let ([fbqueue
;;                     ;; this grossness explained above
;;                     (and 
;;  args
;;                          (not (null? args))
;;                          (let ([handle (car args)])
;;                            (and (symbol? handle)
;;                                 (swl:lookup-fallback-queue handle))))]
;;                    [cbproc (swl:lookup-callback fallback-id)])
;;                (if fbqueue
;;                    (thread-send-msg (unbox fbqueue) (cons cbproc args))
;;  (begin
;;  (fprintf thread-conout "Fallback that had no fbq token: ~s ~s~n" fallback-id args)
;;  (flush-output-port thread-conout)
;;                     ;; this grossness explained above
;;                    (swl:apply-callback-proc cbproc args)))
;;  )
;;              (loop)))))))

;; Wally found that a race condition existed in destroying
;; <container-widget>s where there could still be configure
;; events pending for containers after they were destroyed.
;; Since the problem manifested as a fallback whose widget-hanlde
;; has no fallback-queue, we silently drop these bogus fallbacks.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Get next event from the C event-loop.  If no threads are running
;; then block on the C side so we don't hog CPU.

(define swl:events-dispatched 0)
(define-syntax swl:make-fallback (identifier-syntax cons))
(define-syntax swl:fallback? (identifier-syntax pair?))
(define-syntax swl:fallback-proc (identifier-syntax car))
(define-syntax swl:fallback-args (identifier-syntax cdr))

(define swl:event-dispatch
  (let ()
    (define swl:set-max-block-time
      (lambda (interval) (swl:tcl-eval 'after interval '())))
    (define get-handle car)
    (define mode 'dispatch)
    (define handle-one-event
      (lambda (fallback-id args)
(when (swl:bug)
  (fprintf (swl:bug-port) "swl:event-dispatch:  ~s ~s~n" fallback-id args))
        (let ([fbqueue (swl:lookup-fallback-queue (get-handle args))]
              [cbproc (swl:lookup-callback fallback-id)])       
(when (swl:bug)
  (fprintf (swl:bug-port) "swl:event-dispatch:  fbqueue ~s cbproc ~s~n"
    (if fbqueue 'found 'missing)
    (if cbproc 'found 'missing)))
          (when fbqueue
            (if (eq? mode 'dispatch)
                (begin
                  (thread-send-msg (swl:fbq-queue fbqueue)
                    (swl:make-fallback cbproc args))
                  (set! swl:events-dispatched (fx1+ swl:events-dispatched)))
                (swl:apply-callback-proc cbproc args))))))
    (lambda ()
      (unless thread-sleep-queue-idle?
        (swl:set-max-block-time (thread-sleep-check)))
      (mvlet ((fallback-id args) (swl:do-one-event thread-run-queue-idle?))
         (when fallback-id (handle-one-event fallback-id args))
    ))))

;; added level of indirection to support swl:application-modal
;; (may eventually want to change the thread system to use objects
;;  instead of structures in case there is some indirection in the
;;  low-level queues that we could exploit here)

;; NOTE: if you change the swl:fbq stuff here, change it also in
;;       init.ss   (swl:insert-widget 'swl:system-queue #f (make-swl:fbq q 'swl:system-queue))

;; Not sure this guy really needs to be API procedure.
(define swl:make-fallback-queue
  ;* \formdef{swl:make-fallback-queue}{procedure}{(swl:make-fallback-queue)}
  ;* \ret{see below}
  ;*
  ;* This procedure returns a new event queue and forks off a thread
  ;* to service callback requests delivered to this queue.
  ;* See also the \ref{swl:fallback-queue}
  ;* thread parameter.
  (let ([n 0])
    (lambda ()
      (set! n (+ n 1))
      (let ([q (thread-make-msg-queue 'idle)])
        ;; Fork a thread rather than a thread-group so that the fallback
        ;; thread sees the actual parameters of the application for which
        ;; it is servicing events.
        (thread-fork
          (lambda ()
            (thread-become-server!)
            (call/cc reset-handler)
            (thread-name "Fallback")
            (let loop ()
              (let ([fb (thread-receive-msg q)])
                (cond
                  [(swl:fallback? fb)
                   (swl:apply-callback-proc
                    (swl:fallback-proc fb)
                    (swl:fallback-args fb))]
                  [else (warning #f "unexpected fallback ~s" fb)]))
              (loop)))
          (thread-default-quantum)
          -1) ;;; run with high priority
        (let* ([handle (swl:new-handle #f)]
               [fbq (make-swl:fbq q handle)])
          ; record handle so that menu-items have a way to construct
          ; suitable callback-procs.  (see menu.ss)
          (swl:insert-sticky-widget handle "fbq" fbq)
          fbq)))))

;; set below after thread system is initialized
;; (so that it becomes a thread parameter)
(define swl:fallback-queue)

; BUG:  this guy needs to pass configure events (etc.) through 
(swl:api-procedure swl:application-modal
  ;* \formdef{swl:application-modal}{procedure}{(swl:application-modal \var{application} \var{thunk})}
  ;* \ret{see below}
  ;*
  ;* This procedure returns the result of evaluating \var{thunk}.
  ;* During the evaluation of \var{thunk}, user-interface events
  ;* intended for \var{application} are ignored.  This can be used,
  ;* for example, to implement a file-selection dialog that prevents
  ;* the user from manipulating the calling application until the
  ;* dialog is dismissed.  Note that the threads of the application
  ;* are not suspended; its stream of events is merely redirected
  ;* to a bit sink.  See \ref{swl:make-application}.
  ;   See also \ref{swl:fallback-queue}
  ;   and \ref{get-application-context}.
  (lambda (application thunk)
    (let ([resume (thread-make-msg-queue 'modal)]
          [oldq (swl:fbq-queue application)])
      (set-swl:fbq-queue! application (thread-make-msg-queue '/dev/null))
      (swl:make-application
        (lambda ()
          (call-with-values
            (lambda () (thunk))
            (lambda vals (thread-send-msg resume vals)))))
      (let ([vals (thread-receive-msg resume)])
        (set-swl:fbq-queue! application oldq)
        (apply values vals)))))


(swl:api-procedure swl:make-application
  ;* \formdef{swl:make-application}{procedure}{(swl:make-application \var{thunk})}
  ;* \ret{a new thread}
  ;* \scheme{swl:make-application} insulates the event processing in one
  ;* application from event processing in others by evaluating \var{thunk}
  ;* in a new thread which has a unique
  ;* event queue.  The newly created thread is returned.
  ;* All widgets created during the evaluation of the thunk share the new
  ;* event queue.
  ;* Because events must be processed serially,
  ;* using a single event queue for all applications
  ;* would allow one ill-behaved application to
  ;* prevent other applications in the Scheme session
  ;* from receiving events.
  ; An application is a fine-grained entity consisting of the
  ; widgets created during the evaluation of the thunk.
  (case-lambda
    [(thunk) (swl:make-application thunk (swl:default-quantum))]
    [(thunk quantum)
     (thread-fork-group
       (lambda ()
         (parameterize ((swl:fallback-queue (swl:make-fallback-queue)))
           (thunk)))
       quantum)]))

;; notion is that we stash application along with every widget
;; then when we get a callback for that widget, we grab its application
;; and run with that.
;;
;; to go modal, we would grab the application for the top-level widget
;; of our application and send it a go-modal message.
;;
;; ways to get the application object for a widget:
;;   - table entry associated with every widget handle as it is now
;;     [fast lookup for the event-dispatcher, but more hacky to give
;;      other widgets access to your application]
;;   - have a get-application method on widgets that returns the application
;;     in which they're running (ie. the one servicing their callbacks)
;;     (this could just ask the parent who knows).
;;     or we could have the method access the lookup table described in the
;;     previous option, so we have best of both worlds.
;;
;; ways to associate an application with a widget:
;;   - currently the application for a widget is whatever application ran
;;     the code that created the widget.  (thread parameter)
;;   - could provide a method that bangs on the application stashed in the
;;     lookup table (or ivar) wherever we store this info
;;       - may want this to propagate down from parent to child
;;   - could be part of the context we pass around:  instead of just passing
;;     in a parent for the widgets, we'd pass in a context that knows about
;;       - parent
;;       - application
;;   - could be that parent widget encodes that info, or makes it available
;;     to children who call the "get-application-context" method
;;

; (define-swl-class (<swl-application> thunk) (<base>)
;   (ivars (fallback-queue (swl:make-fallback-queue))
;          (thread (thread-fork-group thunk)))
;   (inherited)
;   (inheritable)
;   (private)
;   (protected)
;   (public
;     [get-fallback-queue () fallback-queue]
;     [set-fallback-queue! (q) (set! fallback-queue q)]
;     [go-modal (thunk)
;      (let ((q fallback-queue))
;        (send self set-fallback-queue! (thread-make-msg-queue 'wait-modal))
;        (swl:make-application thunk)
;        (send self set-fallback-queue! q))]))


(define swl:startup
  ;; it is an error to invoke this more than once (without "-" option)
  (lambda args
    (printf "Welcome to \"SWL\" Version ~a~n" swl:version)
    (printf "Please report \"SWL\" bugs to owaddell@cs.indiana.edu~n")
    (if (and (not (null? args)) (string=? (car args) "-"))
        (begin
          (fluid-let ([require
                       (lambda (x . rest)
                         (printf "loading: ~s~n" x)
                         (load x))])
            (printf "Bypassing SWL initialization to support saving incremental heaps.~n")
            (printf "(No thread or graphics capabilities in this mode.)~n")
            (for-each load (cdr args))
            (new-cafe)))
        (let ((swl-dsp #f))
          (swl:runtime)
          (swl:foreign-init)

          (install-thread-system)
          (swl:init-io-subsystem)

          (swl:install-collect-request-handler)
        
          ;; Really this should be hidden internal to make-application
          (set! swl:fallback-queue
            ;; this documentation won't be seen, (bug)
            (thread-make-parameter
             (swl:make-fallback-queue)
             (lambda (x) x)))
          
          (initialize-graphics-lib)

          (set! thread-timer-interrupt-hook
            (lambda ()
              (when (and (not (eq? (thread-self) swl-dsp)) (swl:peek-event))
                (thread-reschedule swl-dsp (thread-highest-priority))
                (thread-yield))))
          
          ;; go into infinite loop servicing events
          (set! swl-dsp
            (thread-fork-group
             (lambda ()
               (thread-name "Event Dispatcher")
               (call/cc
                (lambda (reset-k) (thread-become-server! reset-k)))
               (let loop ()
                 (thread-yield)
                 (swl:event-dispatch)
                 (loop)))
             (thread-default-quantum)
             (thread-lowest-priority)
             ))

          (if #t ; (memq (machine-type) '(ppcaix ppcnt i3nt))
              ;; always use graphical repl.
              ;; use graphical repl from ../../apps/repl if console buggy
              (call/cc
                (lambda (bugout)
          ;;(reset-handler
          ;; (lambda () '(fprintf thread-conout "SWL: console reset~n")))
                  (let ([app-q (thread-make-msg-queue 'app-q)]
                        [token-q (thread-make-msg-queue 'token-q)]
                        [applications '()])

                    (define fold
                      (lambda (ls b fn)
                        (if (null? ls) b (fn (car ls) (fold (cdr ls) b fn)))))

                    (define swl:splash-screen
                      (lambda ()
                        (define-class (<splash-can> parent) (<canvas> parent)
                            (ivars)
                            (inherited)
                            (inheritable)
                            (private)
                            (protected)
                            (public
                              [key-press (key mods) (send (send self get-parent) destroy)]
                              [mouse-press (x y mods) (send (send self get-parent) destroy)]))
                        (swl:make-application
                         (lambda ()
; probably should complain if image file not found
                           (let* ([img (swl:with-library-file "splash.gif"
                                         (lambda (path)
                                           (create <photo> with (filename: path))))]
                                  [iw (send img get-width)] [ih (send img get-height)]
                                  [sp (create <toplevel> with (width: iw) (height: ih) (title: "SWL")
                                        (override-redirect: #t)
                                        (geometry:
                                          (format "+~a+~a"
                                            (fxquotient (fx- (swl:screen-width) (send img get-width)) 2)
                                            (fxquotient (fx- (swl:screen-height) (send img get-height)) 2))))]
                                  [splash-can (create <splash-can> sp with (width: iw) (height: ih) (border-width: 0))])
                             (create <canvas-image> splash-can 0 0 with (anchor: 'nw) (image: img))
                             (let ([fnt (create <font> 'times 18 '(bold))])
                               (create <canvas-text> splash-can 90 170 with     ; or 55 170   to left align
                                 (title:
                                  (format "~aChez Scheme Version ~a"
                                    (if (system-ref '\#compiler-is-loaded?)
                                        ""
                                        "Petite ")
                                    (system-ref '|#scheme-version|)))
                                 (anchor: 'nw)
                                 (fill-color: 'red)
                                 (font: fnt)))
                             (let ([fnt (create <font> 'helvetica 14 '())])
;                               (create <canvas-text> splash-can 90 210 with     ; or 55 210   to left align
;                                 (title: "Copyright (c) 1998 Cadence Research Systems")
;                                 (anchor: 'nw)
;                                 (font: fnt))
                               (create <canvas-text> splash-can 90 210 with     ; or 55 210
                                 (title: (format "SWL Version ~a" swl:version))
                                 (anchor: 'nw)
                                 (font: fnt)))
                             (show splash-can)
                             (show sp)
                             (raise sp)
                             (thread-sleep 6000)
                             (send sp destroy))))))

                       (define build-update-menu-parameter
                        ; Note: it's important to have the (swl:make-application proc) below
                        ;       or else REPLs forked from the menu have bum parameters and their
                        ;       begin-exp mark gets out of sync (? wrong waiter-prompt-and-read).
                         (lambda (who menu-title default-items)
                           (let ((items '()) (cascades '()))
                             (define-class (<collected-cascade>) (<cascade-menu-item>)
                               (ivars)
                               (inherited)
                               (inheritable)
                               (private)
                               (protected)
                               (public
                                 [init ()
                                  (critical-section
                                    (set! cascades (cons self cascades)))]
                                 [destroy ()
                                  (critical-section
                                    (send-base self destroy)
                                    (set! cascades (remq self cascades)))]))
                             (define build-item
                               (lambda (item)
                                 (let ([title (car item)] [proc (cdr item)])
                                   (create <command-menu-item> with
                                     (title: title)
                                     (action: (lambda (i) (swl:make-application proc)))))))
                             (define build-default-items
                               (lambda ()
                                 (let ([ls (map build-item default-items)])
                                   (if (null? ls)
                                       ls
                                       (cons (create <separator-menu-item>) ls)))))
                             (define build-menu
                               (lambda ()
                                 (let f ([ls items] [mis (build-default-items)])
                                   (if (null? ls)
                                       (create <menu> mis)
                                       (f (cdr ls) (cons (build-item (car ls)) mis))))))
                             (define title-follows?
                               (lambda (x y)
                                 (string-ci>?
                                   (if (pair? x) (car x) x)
                                   (if (pair? y) (car y) y))))
                             (case-lambda
                               [()
                                (create <collected-cascade> with (title: menu-title) (menu: (build-menu)))]
                               [(title proc)
                                (unless (or (string? title)
                                            (and (pair? title)
                                                 (string? (car title))
                                                 (string? (cdr title))))
                                  (error who "~s is not a valid title for a help menu item" title))
                                (unless (or (not proc) (procedure? proc))
                                  (error who "~s is not #f or a procedure" proc))
                                (let ([hit (assoc title items)])
                                  (if proc
                                      (if hit
                                          (set-cdr! hit proc)
                                          (set! items
                                            (sort title-follows? (cons (cons title proc) items))))
                                      (when hit (set! items (remq hit items)))))
                                (for-each
                                  (lambda (i) (set-menu! i (build-menu)))
                                  cascades)]))))

                     (swl:api-procedure swl:application-menu
                       ;* \formdef{swl:application-menu}{procedure}{(swl:application-menu)}
                       ;* \returns {an instance of \scheme{<cascade-menu-item>}}
                       ;* \formdef{swl:application-menu}{procedure}{(swl:application-menu title thunk)}
                       ;* \ret{unspecified}
                       ;* When invoked with no arguments, \scheme{swl:application-menu}
                       ;* returns a cascade menu item for use as a top level entry
                       ;* in the menu of a \scheme{<toplevel>} (\emph{i.e.} supplied as the
                       ;* \scheme{menu:} attribute of the \scheme{<toplevel>} or installed
                       ;* via its \scheme{set-menu!} method).
                       ;* 
                       ;* When invoked with two arguments, \scheme{swl:application-menu} expects
                       ;* \scheme{title} to be a valid \scheme{<command-menu-item>} title
                       ;* (except that images are not allowed due to incompatibilities with
                       ;* Windows platforms) and \scheme{thunk} to be either a procedure of
                       ;* no arguments, to be invoked when this menu item is chosen, or \scheme{#f}.
                       ;* If \scheme{thunk} is a procedure, then existing and future SWL application
                       ;* menus will contain an entry with the given title that invokes this
                       ;* procedure.  If \scheme{thunk} is \scheme{#f}, the corresponding menu
                       ;* entry (if any) is removed from all SWL application menus.
                       ;* Items on the SWL application menu are sorted alphabetically, except
                       ;* the last two items:  one titled ``Version...'' that displays the
                       ;* version information on the initial splash screen and one titled
                       ;* ``Exit SWL'' that does what you might expect.
                       ;* These default menu entries cannot be removed.
                       (build-update-menu-parameter 'swl:application-menu "_SWL"
                         (list (cons "_Version..." (lambda () (swl:splash-screen)))
                               (cons "E_xit SWL" (lambda () (swl:end-application 'exit-all))))))

                     (swl:api-procedure swl:help-menu
                       ;* \formdef{swl:help-menu}{procedure}{(swl:help-menu)}
                       ;* \returns {an instance of \scheme{<cascade-menu-item>}}
                       ;* \formdef{swl:help-menu}{procedure}{(swl:help-menu title thunk)}
                       ;* \ret{unspecified}
                       ;* When invoked with no arguments, \scheme{swl:help-menu}
                       ;* returns a cascade menu item for use as a top level entry
                       ;* in the menu of a \scheme{<toplevel>} (\emph{i.e.} supplied as the
                       ;* \scheme{menu:} attribute of the \scheme{<toplevel>} or installed
                       ;* via its \scheme{set-menu!} method).
                       ;* 
                       ;* When invoked with two arguments, \scheme{swl:help-menu} expects
                       ;* \scheme{title} to be a valid \scheme{<command-menu-item>} title
                       ;* (except that images are not allowed due to incompatibilities with
                       ;* Windows platforms) and \scheme{thunk} to be either a procedure of
                       ;* no arguments, to be invoked when this menu item is chosen, or \scheme{#f}.
                       ;* If \scheme{thunk} is a procedure, then existing and future SWL help
                       ;* menus will contain an entry with the given title that invokes this
                       ;* procedure.  If \scheme{thunk} is \scheme{#f}, the corresponding menu
                       ;* entry (if any) is removed from all SWL help menus.
                       ;* Items on the SWL help menu are sorted alphabetically, except that the
                       ;* last item is always a ``Documentation'' button that displays the
                       ;* online documentation.
                       ;* The default menu entry cannot be removed.
                       (build-update-menu-parameter 'swl:help-menu "_Help"
                         (list 
                               (cons "_About SWL"
                                     (lambda ()
                                       (swl:with-library-file
                                         "about.html"
                                         new-viewer)))
                               (cons "_Documentation"
                                     (if (memq (machine-type) '(i3nt ppcnt))
                                         (swl:with-library-file "index.html"
                                           (lambda (index)
                                             (lambda ()
                                               (when (<= (swl:open-dde-file index "" "") 32)
                                                 (new-viewer)))))
                                         new-viewer)))))

                     (swl:api-procedure swl:begin-application
                       ;* \formdef{swl:begin-application}{procedure}{(swl:begin-application \var{exit-thunk})}
                       ;* \ret{see below}
                       ;* Add the current application instance to a list
                       ;* of protected applications that must be exited
                       ;* before SWL
                       ;* exits.  Returns a token that must be passed
                       ;* to \scheme{swl:end-application} when the application
                       ;* exits.  The \var{exit} is called to notify
                       ;* the application of SWL system shutdown requests.
                       (lambda (exit)
                         (thread-send-msg app-q (cons 'start exit))
                         (thread-receive-msg token-q)))

                     (swl:api-procedure swl:end-application
                       ;* \formdef{swl:end-application}{procedure}{(swl:end-application \var{token})}
                       ;* \ret{unspecified}
                       ;* Remove from the list
                       ;* of active applications the instance granted this
                       ;* token and invoke the exit thunk supplied at that
                       ;* time (see \ref{swl:begin-application}).
                       ;* If \var{token} is the symbol \scheme{exit-all}, invoke the
                       ;* remaining exit thunks and exit SWL if no protected
                       ;* applications remain.
                       (lambda (token)
                         (thread-send-msg app-q (cons 'end token))))

                    ; moved this here from repl.ss (etc) for saved heap
                    (swl:application-menu "New _Editor" new-edit)
                    (swl:application-menu "New _REPL" new-repl)

                    (swl:help-menu "for _Editor"
                      (lambda () (swl:with-library-file "edit.html" new-viewer)))
                          
                    (swl:help-menu "for _REPL"
                      (lambda () (swl:with-library-file "repl.html" new-viewer)))

                    ;; Have to do this after the above have been exported.
                    (console-error-port (swl:error-log-port))

                    ;; The thread system expects evaluation to be done in the
                    ;; context of a new-cafe, so we'll give him one.
                    ;;
                    ;; 3-D code (which Chez Scheme can handle) makes this quite
                    ;; nice:  no need to gum up the top level environment with
                    ;; a binding to get the actual waiter prompt and read during
                    ;; the evaluation of loads.
                    ;; 
                    ;; Of course, I'll be a good boy and avoid 3-D code.
                    ;; I'll stash the goods on the property list of a gensym
                    ;; and remprop it so that the gensym can be collected.
                    ;; (at least I hope its collectable in this case)
;                   (parameterize
;                     ((waiter-prompt-and-read
;                        (let ([eof? #f])
;                          (lambda ignore
;                            (if eof?
;                                #!eof
;                                (begin
;                                  (set! eof? #t)
;                                  `(parameterize ([waiter-prompt-and-read
;                                                   ,(waiter-prompt-and-read)])
;                                     (for-each load ',args))))))))
;                     (new-cafe))
                    (unless (null? args)
                      (parameterize
                        ((waiter-prompt-and-read
                           (let ([eof? #f] [hack (gensym)])
                             (putprop hack hack (waiter-prompt-and-read))
                             (lambda ignore
                               (if eof?
                                   #!eof
                                   (begin
                                     (set! eof? #t)
                                     `(parameterize ([waiter-prompt-and-read
                                                      (getprop ',hack ',hack)])
                                        (remprop ',hack ',hack)
                                        (for-each load ',args))))))))
                        (new-cafe)))

                    (new-repl (lambda (repl) (thread-sleep 250) (swl:splash-screen)) list)
                    
                    (let ([insts '()])
                      (let loop ()
                        (let ([msg (thread-receive-msg app-q)])
                          (when (pair? msg)
                            (case (car msg)
                              [(start)
                               (let ([exit (cdr msg)])
                                 (let ([token (string #\t)])
                                   (thread-send-msg token-q token)
                                   (set! insts
                                     (cons (cons token exit) insts))))]
                              [(end)
                               (let ([token (cdr msg)])
                                 (if (eq? token 'exit-all)
                                     (for-each (lambda (x) ((cdr x))) insts)
                                     (set! insts
                                       (let rem ([insts insts])
                                         (cond
                                           [(null? insts) '()]
                                           [(eq? token (caar insts))
                                            (cdr insts)]
                                           [else
                                            (cons (car insts)
                                                  (rem (cdr insts)))])))))]))
                          (unless (null? insts) (loop)))))
                   )))
                (begin (swl:install-non-blocking-console) (new-cafe)))))))

(parameterize ((subset-mode 'system))
  (eval '(set! \#as-time-goes-by
          ; top-level-value is to prevent optimizer from propagating reference
           (let ((atgb (top-level-value '\#as-time-goes-by)))
             (lambda (e t)
               (fprintf (console-output-port)
                 "Warning (time): thread system overhead skews timing results~%")
               (set! \#as-time-goes-by atgb)
               (atgb e t))))))
